//
//  Shader2.fsh
//  GLES2.0 Sample
//
//  Created by Satoshi Numata on 12/04/22.
//  Copyright (c) 2012 Sazameki and Satoshi Numata, Ph.D. All rights reserved.
//

varying lowp vec2 texUVVarying;

uniform sampler2D texture0;
uniform lowp float time;

lowp vec4 convertToSepia(lowp vec4 color)
{
    const lowp vec3 rgb_to_yuv = vec3(0.299, 0.587, 0.114);
    const lowp vec3 i_to_rgb = vec3(0.956, -0.272, -1.108);
    const lowp vec3 q_to_rgb = vec3(0.620, -0.647, 1.705);
    const lowp float i = 0.2;
    const lowp float q = 0.0;
    
    lowp float y = dot(rgb_to_yuv, color.rgb);
    y *= 1.4;
    if (y > 1.0) {
        y = 1.0;
    }
    return vec4(y+i_to_rgb*i+q_to_rgb*q, color.a);
}

lowp vec4 addScanLine(lowp vec4 color)
{
    const lowp float density = 480.0*3.14/2.0;
    //const lowp float brightness = 0.75;
    const lowp float brightness = 0.5;
    
    lowp vec4 ret = color;
    ret.rgb *= (sin(texUVVarying.y*density-time)+1.0)*0.5*(1.0-brightness)+brightness;
    return ret;
}

void main()
{
    lowp vec4 texColor0 = texture2D(texture0, texUVVarying).rgba;
    
    lowp vec4 color = texColor0;
    color = convertToSepia(color);
    color = addScanLine(color);

    gl_FragColor = color;
}
