//
//  Shader.vsh
//  GLES2.0 Sample
//
//  Created by Satoshi Numata on 12/04/21.
//  Copyright (c) 2012 Sazameki and Satoshi Numata, Ph.D. All rights reserved.
//

attribute vec4 position;
attribute vec3 normal;
attribute vec2 texUV;

varying lowp vec3 colorVarying;
varying lowp vec2 texUVVarying;

uniform mat4 modelMatrix;
uniform mat4 modelViewProjectionMatrix;
uniform mat3 normalMatrix;
uniform vec3 lightVec;

void main()
{
    vec3 diffuseColor = vec3(1.0, 1.0, 1.0);
    vec3 ambientColor = vec3(0.1, 0.1, 0.1);
    vec3 theNormal = mat3(modelMatrix) * normal;
    
    float nDotVP = max(0.0, dot(theNormal, normalize(-lightVec)));
                 
    colorVarying = diffuseColor * nDotVP + ambientColor;
    
    gl_Position = modelViewProjectionMatrix * position;
    texUVVarying = texUV;
}
